﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Collections.Specialized
Namespace System.Collections.Generic

   Public Class ResetList(Of T) : Inherits ObservableCollection(Of T)
      Public Overridable Sub AddRange(news As IEnumerable(Of T), Optional overrideStart As Integer = -1)
         Dim l = InnerList
         Dim cnt = l.Count
         If overrideStart >= 0 Then
            If overrideStart = 0 Then
               l.Clear()
            Else
               l.RemoveRange(overrideStart, cnt - overrideStart)
            End If
         End If
         l.AddRange(news)
         If cnt <> l.Count Then Me.OnPropertyChanged(New PropertyChangedEventArgs("Count"))
         Me.OnPropertyChanged(New PropertyChangedEventArgs("Item[]"))
         RaiseReset()
      End Sub
      Public Sub RaiseReset()
         MyBase.OnCollectionChanged(New NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset))
      End Sub
      Public ReadOnly Property InnerList As List(Of T)
         <DebuggerStepThrough()> _
         Get
            Return DirectCast(Items, List(Of T))
         End Get
      End Property
   End Class

End Namespace