﻿Namespace System.Runtime.CompilerServices

   Public MustInherit Class WeakAttachBase2(Of TKey As Class, Tself As {WeakAttachBase2(Of TKey, Tself), New})

      Private Shared ReadOnly _IListFields As New ConditionalWeakTable(Of TKey, Tself)

      Private Shared creater As ConditionalWeakTable(Of TKey, Tself).CreateValueCallback = _
         Function(k) New Tself With {._Key = k}

      Protected _Key As TKey

      Public Shared Function GetAttached(key As TKey) As Tself
         Return _IListFields.GetValue(key, creater)
      End Function

   End Class


   Public MustInherit Class WeakAttachBase(Of Tself As {WeakAttachBase(Of Tself), New})
      Public Shared ReadOnly Attachs As New ConditionalWeakTable(Of Object, Tself)
      Protected Shared creater As ConditionalWeakTable(Of Object, Tself).CreateValueCallback = Function(k) New Tself

      Public Shared Function [Get](key As Object) As Tself
         Return Attachs.GetValue(key, creater)
      End Function
      Public Shared Function CreateIfMissing(key As Object, ByRef value As Tself) As Boolean
         CreateIfMissing = Not Attachs.TryGetValue(key, value)
         If CreateIfMissing Then
            value = creater(key)
            Attachs.Add(key, value)
         End If
      End Function
      Public Shared Function Exists(key As Object) As Boolean
         Dim value As Tself = Nothing
         Return Attachs.TryGetValue(key, value)
      End Function
   End Class


   'Public MustInherit Class WeakAttachBase(Of TKey As Class, Tself As {WeakAttachBase(Of TKey, Tself), New})
   '   Public Shared ReadOnly Attachs As New ConditionalWeakTable(Of Object, Tself)
   '   Protected Shared creater As ConditionalWeakTable(Of Object, Tself).CreateValueCallback = Function(k) New Tself

   '   Public Shared Function [Get](key As Object) As Tself
   '      Return Attachs.GetValue(key, creater)
   '   End Function
   '   Public Shared Function CreateIfMissing(key As Object, ByRef value As Tself) As Boolean
   '      CreateIfMissing = Not Attachs.TryGetValue(key, value)
   '      If CreateIfMissing Then
   '         value = creater(key)
   '         Attachs.Add(key, value)
   '      End If
   '   End Function
   '   Public Shared Function Exists(key As Object) As Boolean
   '      Dim value As Tself = Nothing
   '      Return Attachs.TryGetValue(key, value)
   '   End Function
   'End Class

   'Public MustInherit Class WeakAttachBase(Of TKey As Class, Tself As {WeakAttachBase(Of TKey, Tself), New})
   '     Private Shared ReadOnly _IListFields As New ConditionalWeakTable(Of Object, Tself)
   '     Private Shared creater As ConditionalWeakTable(Of Object, Tself).CreateValueCallback = _
   '      Function(k) New Tself With {._Key = (DirectCast(k, TKey))}
   '     Protected _Key As TKey
   '     Public Shared Function GetAttached(key As Object) As Tself
   '      Return _IListFields.GetValue(key, creater)
   '   End Function
   '  End Class

End Namespace
