﻿Option Compare Text

Imports System.Runtime.CompilerServices
Imports System.Text
Imports System.Collections
Imports System.Text.RegularExpressions
Imports System.Globalization
Imports System.ComponentModel

Namespace System

   Public Module StringX

      Private _Counter, _MaxCount As Integer
      Private _patterns As Char() = ",:0123456789".ToCharArray
      Private Function FormatXEvaluater(mt As Match) As String
         Dim s = mt.Value
         Dim i = s.IndexOfAny(_patterns)
         If i > 0 AndAlso Array.IndexOf(_patterns, s(i)) > 1 Then Return s
         If _Counter < _MaxCount Then _Counter += 1
         Return s.Insert(1, _Counter.ToString)
      End Function
      ''' <summary> funzt wie String.Format, nur wird in leere '{}' laufende Nummern eingetragen - jedoch nicht höhere als Anzahl args. Sodass das letzte arg auch vielfach eingefügt werden kann </summary>
      <Extension()> _
      Public Function FormatX(sFormat As String, ParamArray args As Object()) As String
         _Counter = -1 : _MaxCount = args.Length - 1
         Dim s = Regex.Replace(sFormat, "(?<=([^{]|^)({{)*){[^{}]*[}]", AddressOf FormatXEvaluater)
         Return String.Format(s, args)
      End Function

#If True Then
#ElseIf True Then
#ElseIf True Then
#ElseIf True Then
      Private Function FormatXEvaluater(mt As Match) As String
         If _Counter < _MaxCount Then _Counter += 1
         Return mt.Value.Insert(1, _Counter.ToString)
      End Function
      ''' <summary> funzt wie String.Format, nur wird in leere '{}' laufende Nummern eingetragen - jedoch nicht höhere als Anzahl args. Sodass das letzte arg auch vielfach eingefügt werden kann </summary>
      <Extension()> _
      Public Function FormatX(sFormat As String, ParamArray args As Object()) As String
         _Counter = -1 : _MaxCount = args.Length - 1
         Dim s = Regex.Replace(sFormat, "(?<=([^{]|^)({{)*){}", AddressOf FormatXEvaluater)
         Return String.Format(s, args)
      End Function
#ElseIf True Then
  'FormatX-Variante, bei der die schließende '}' auch weggelassen werden kann.
      Private Function FormatXEvaluater(mt As Match) As String
         If _Counter < _MaxCount Then _Counter += 1
         Dim s = If(mt.Length = 2 AndAlso mt.Value(1) = "}"c, _Counter.ToString, _Counter.ToString & "}")
         Return mt.Value.Insert(1, s)
      End Function
      ''' <summary> funzt wie String.Format, nur wird in leere '{}' laufende Nummern eingetragen - jedoch nicht höhere als Anzahl args. Sodass das letzte arg auch vielfach eingefügt werden kann </summary>
      <Extension()> _
      Public Function FormatX(sFormat As String, ParamArray args As Object()) As String
         _Counter = -1 : _MaxCount = args.Length - 1
         Dim s = Regex.Replace(sFormat, "(?<=([^{]|^)({{)*){([^{0-9]|$)", AddressOf FormatXEvaluater)
         Return String.Format(s, args)
      End Function
#ElseIf True Then
#End If


      ''' <summary> positive value cuts from left, negative cuts from right </summary>
      <Extension()> _
      Public Function SubstringX(Subj As String, cut As Integer) As String
         If cut < 0 Then Return Subj.Substring(0, Subj.Length + cut)
         Return Subj.Substring(cut)
      End Function
      ''' <summary> start and end instead of start and length. Adds negative numbers to Subj.Length </summary>
      <Extension()> _
      Public Function SubstringX(Subj As String, start As Integer, [end] As Integer) As String
         If start < 0 Then start += Subj.Length
         If [end] <= 0 Then [end] += Subj.Length
         Return Subj.Substring(start, [end] - start)
      End Function

      ''' <summary> more comfortable than String.Split(separator as String(),count,mode) </summary>
      <Extension()> _
      Public Function Split(Subj As String, separator As String, count As Integer, Optional mode As StringSplitOptions = StringSplitOptions.None) As String()
         Return Subj.Split(New String() {separator}, count, mode)
      End Function
      <Extension()> _
      Public Function Replace(Subj As String, oldValue As String, ParamArray concatNewValues() As Object) As String
         Return Subj.Replace(oldValue, String.Concat(concatNewValues))
      End Function

      ''' <summary> more comfortable to use than String.Split(separator as String(),mode) </summary>
      <Extension()> _
      Public Function Split(Subj As String, separator As String, Optional mode As StringSplitOptions = StringSplitOptions.None) As String()
         Return Subj.Split(New String() {separator}, mode)
      End Function

      ''' <summary> verkettet alles </summary>
      <Extension()> _
      Public Sub [Set](ByRef Subj As String, ParamArray others() As Object)
         Subj = String.Concat(others)
      End Sub

      <EditorBrowsable(EditorBrowsableState.Never)> _
      Public Function ReplaceBslashN(s As String) As String
         Dim sb As New StringBuilder
         For i = 0 To s.Length - 2 Step 2
            If s.IndexOf("\n", i, 2) < 0 Then Exit For
            sb.Append(CrLf)
         Next
         sb.Append(s.Substring(sb.Length))
         Return sb.ToString
      End Function

      '''<summary> verkettet alles, interpretiert \n am Anfang als newline</summary>
      <Extension()> _
      Public Function And2(Subj As String, ParamArray others() As Object) As String
         Dim sb = New StringBuilder(ReplaceBslashN(Subj))
         For Each itm In others
            sb.Append(ReplaceBslashN(itm.ToString))
         Next
         Return sb.ToString
      End Function

      '''<summary> verkettet alles</summary>
      <Extension()> _
      Public Function [And](Subj As String, ParamArray others() As Object) As String
         Return String.Concat(Subj, String.Concat(others))
      End Function

      ''' <returns>den Stringabschnitt ab dem letzten Auftreten von sMatch (ohne sMatch)</returns>
      <Extension()> _
      Public Function LastRightCut(s As String, sMatch As String) As String
         Dim i = s.LastIndexOf(sMatch)
         If i < 0 Then Return Nothing
         Return s.Substring(i + sMatch.Length)
      End Function

      ''' <returns>den Stringabschnitt ab dem ersten Auftreten von sMatch (ohne sMatch)</returns>
      <Extension()> _
      Public Function RightCut(S$, sMatch$) As String
         Dim I% = S.IndexOf(sMatch)
         If I < 0 Then Return Nothing
         Return S.Substring(I + sMatch.Length)
      End Function

      Public Function CreateUnescapeRegex(Pattern As String) As Regex
         Return New Regex("(?<=(^|[^\\](\\\\)*))" & Pattern) 'der vorangestellte Pattern schließt escaped Matches ('\X' etc.) aus
      End Function

      ''' <summary>gibt den String-Abschnitt links des ersten gefundenen Matches zurück</summary>
      <Extension()> _
      Public Function LastLeftCut(Subj As String, Pattern As String) As String
         Dim i = Subj.LastIndexOf(Pattern)
         Return If(i >= 0, Subj.Remove(i), Nothing)
      End Function

      ''' <summary>
      ''' gibt den String-Abschnitt links des ersten gefundenen Matches zurück
      ''' </summary>
      <Extension()> _
      Public Function LeftCut(Subj As String, Pattern As String) As String
         Dim i = Subj.IndexOf(Pattern)
         Return If(i >= 0, Subj.Remove(i), Nothing)
      End Function

      Public Enum Additional : None : Start : [End] : Start_End : End Enum
      <Extension()> _
      Public Function Between(separator As Char, additional As Additional, ParamArray args() As Object) As String
         Return Between(args, separator, additional)
      End Function
      <Extension()> _
      Public Function Between(separator As Char, ParamArray args() As Object) As String
         Return Between(args, separator, Additional.None)
      End Function
      <Extension()> _
      Public Function Between(separator As String, additional As Additional, ParamArray args() As Object) As String
         Return Between(args, separator, additional)
      End Function
      <Extension()> _
      Public Function Between(separator As String, ParamArray args() As Object) As String
         If args.Length = 1 Then
            'special: args is just 2 chars in a string - treat the chars as opening and closing bracket or Quotes
            Dim s As String = TryCast(args(0), String)
            If s.NotNull AndAlso s.Length = 2 Then Return String.Concat(s(0), separator, s(1))
         End If
         Return Between(args, separator, Additional.None)
      End Function

      Private _SB As New System.Text.StringBuilder
      Private Function Between(args() As Object, separator As String, additional As Additional) As String
         Try
            While args.Length < 2 AndAlso Not TypeOf args(0) Is String
               args = DirectCast(args(0), IEnumerable).Cast(Of Object).ToArray
            End While
         Catch ex As Exception ' can be InvalidCast or IndexOutOfRange
         End Try
         _SB.Clear()
         If additional.HasFlag(additional.Start) Then _SB.Append(separator)
         _SB.Append(String.Join(separator, args))
         If additional.HasFlag(additional.End) Then _SB.Append(separator)
         Return _SB.ToString
      End Function

      <Extension()> _
      Public Function CountChars(ByVal S As String, ByVal Search As Char) As Integer
         CountChars = 0
         Dim I As Integer = S.IndexOf(Search)
         While I >= 0
            CountChars += 1
            I = S.IndexOf(Search, I + 1)
         End While
      End Function

      <Extension()> _
      Public Function CountSubStrings(ByVal S As String, ByVal Search As String, _
            Optional ByVal Comparison As StringComparison = StringComparison.CurrentCulture) As Integer
         CountSubStrings = 0
         Dim I As Integer = S.IndexOf(Search, 0, Comparison)
         While I >= 0
            CountSubStrings += 1
            I = S.IndexOf(Search, I + 1, Comparison)
         End While
      End Function

   End Module


End Namespace