﻿Imports System.Runtime.CompilerServices

Public Module DateTimeX

   Public Enum TimeUnit : Tick : Millisecond : Second : Hour : Day : End Enum
   Public _TicksPerUnit As Long() = {1, TimeSpan.TicksPerMillisecond, TimeSpan.TicksPerSecond, TimeSpan.TicksPerMinute, TimeSpan.TicksPerHour, TimeSpan.TicksPerDay}

   <Extension>
   Public Function Align(dt As Date, unit As TimeUnit) As Date
      Dim rest As Long = 0
      Dim ticks = Math.DivRem(dt.Ticks, _TicksPerUnit(unit), rest)
      Return dt.AddTicks(-rest)
   End Function

   Sub TestAlign()
      Dim dt0 = Date.Now
      Dim dt1 = dt0.AddTicks(123456)
      Dim dt2 = Align(dt1, TimeUnit.Second)
      Dim ts0 = dt0.TimeOfDay
      Dim ts1 = dt1.TimeOfDay
      Dim ts2 = dt2.TimeOfDay
   End Sub ' <-- am Haltepunkt die Timespans vergleichen

End Module
