﻿Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.IO

Public Class MainModel : Inherits MainModelBase(Of MainModel)

   Private _DataFile As New FileInfo("..\..\PersonData.txt")

   Private __Persons As New ObservableCollection(Of Person)()
   Public Property Persons() As ICollectionView = CollectionViewSource.GetDefaultView(__Persons)

   Public Property cmdFill() As New RelayCommand(AddressOf Load)

   Public Property cmdSave() As New RelayCommand(AddressOf Save)

   Public Property cmdDoSomething() As New RelayCommand(AddressOf DoSomethingWithAPerson, Function() Persons.CurrentPosition >= 0)

   Public Property TestString As String = "Halo"

   Public Sub New()
      If IsProvisional Then ' TestData for Designer-Work
         Call 10.Times.From(__Persons.Count, Sub(i) __Persons.Add(Person.FromInt(i)))
      End If
   End Sub

   Private Sub Save()
      Using writer = _DataFile.CreateText
         For Each Person In __Persons
            writer.WriteLine("{0}°{1}°{2}", Person.Name, Person.Phone, Person.BirthDay)
         Next
      End Using
      System.Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Load()
      __Persons.Clear()
      Using reader = _DataFile.OpenText
         While Not reader.EndOfStream
            Dim data = reader.ReadLine.Split("°"c)
            __Persons.Add(New Person(data(0), data(1), Date.Parse(data(2))))
         End While
      End Using
   End Sub

   Private Sub DoSomethingWithAPerson()
      Dim person = __Persons(Persons.CurrentPosition)
      Msg("Geklickt wurde auf: ", person.Name)
   End Sub

End Class
